// Copyright (c) 2004 pruet boonma <pruet@eng.cmu.ac.th>
import java.util.Enumeration;
import java.util.Hashtable;

import javax.microedition.rms.RecordEnumeration;
import javax.microedition.rms.RecordStore;

public class Setting
{
    Hashtable hashStorage;
    Hashtable rmsIdHash;
    RecordStore rmsStorage;
    String name;
    final char sep = '=';
    final char end = '|';
    
    Setting(String string) {
	init(string, new Hashtable());
    }
    
    Setting(String string, String string_0_) {
	init(string, Utils.string2hash(string_0_, '=', '|'));
    }
    
    Setting(String string, Hashtable hashtable) {
	init(string, hashtable);
    }
    
    Setting(String string, Setting setting_1_) {
	init(string, setting_1_.getHashtable());
    }
    
    protected void init(String string, Hashtable hashtable) {
	((Setting) this).name = string;
	if (((Setting) this).name != null && !((Setting) this).name.equals("")
	    && hashtable != null) {
	    Hashtable hashtable_2_ = hashtable;
	    ((Setting) this).rmsIdHash = new Hashtable();
	    ((Setting) this).hashStorage = new Hashtable();
	    try {
		((Setting) this).rmsStorage
		    = RecordStore.openRecordStore(((Setting) this).name, true);
		int i = hashtable_2_.size();
		int i_3_ = ((Setting) this).rmsStorage.getNumRecords();
		if (i_3_ > 0) {
		    RecordEnumeration recordenumeration
			= ((Setting) this).rmsStorage
			      .enumerateRecords(null, null, false);
		    while (recordenumeration.hasNextElement()) {
			int i_4_ = recordenumeration.nextRecordId();
			String string_5_
			    = new String(((Setting) this).rmsStorage
					     .getRecord(i_4_));
			int i_6_ = string_5_.indexOf('=');
			String string_7_ = string_5_.substring(0, i_6_);
			((Setting) this).hashStorage.put
			    (string_7_,
			     string_5_.substring(i_6_ + 1,
						 string_5_.length()));
			((Setting) this).rmsIdHash.put(string_7_,
						       new Integer(i_4_));
		    }
		}
		if (i > 0) {
		    Enumeration enumeration = hashtable_2_.keys();
		    while (enumeration.hasMoreElements()) {
			String string_8_ = (String) enumeration.nextElement();
			if (i_3_ == 0 || !((Setting) this).hashStorage
					      .containsKey(string_8_)) {
			    String string_9_
				= (String) hashtable_2_.get(string_8_);
			    ((Setting) this).hashStorage.put(string_8_,
							     string_9_);
			    String string_10_ = string_8_ + '=' + string_9_;
			    int i_11_ = (((Setting) this).rmsStorage.addRecord
					 (string_10_.getBytes(), 0,
					  string_10_.length()));
			    ((Setting) this).rmsIdHash.put(string_8_,
							   new Integer(i_11_));
			}
		    }
		}
		((Setting) this).rmsStorage.closeRecordStore();
		System.gc();
	    } catch (Exception exception) {
		exception.printStackTrace();
	    }
	}
    }
    
    public String get(String string) {
	return (String) ((Setting) this).hashStorage.get(string);
    }
    
    public void set(String string, String string_12_) {
	if (((Setting) this).name != null && !((Setting) this).name.equals("")
	    && string != null && !string.equals("") && string_12_ != null) {
	    try {
		((Setting) this).rmsStorage
		    = RecordStore.openRecordStore(((Setting) this).name, true);
		if (((Setting) this).hashStorage.containsKey(string)) {
		    String string_13_ = string + '=' + string_12_;
		    ((Setting) this).rmsStorage.setRecord
			(((Integer) ((Setting) this).rmsIdHash.get(string))
			     .intValue(),
			 string_13_.getBytes(), 0,
			 string_13_.getBytes().length);
		    ((Setting) this).hashStorage.put(string, string_12_);
		} else {
		    String string_14_ = string + '=' + string_12_;
		    int i = (((Setting) this).rmsStorage.addRecord
			     (string_14_.getBytes(), 0, string_14_.length()));
		    ((Setting) this).rmsIdHash.put(string, new Integer(i));
		    ((Setting) this).hashStorage.put(string, string_12_);
		}
		((Setting) this).rmsStorage.closeRecordStore();
	    } catch (Exception exception) {
		exception.printStackTrace();
	    }
	}
    }
    
    public boolean contains(String string) {
	return ((Setting) this).hashStorage.containsKey(string);
    }
    
    public Hashtable getHashtable() {
	return ((Setting) this).hashStorage;
    }
    
    public String getName() {
	return ((Setting) this).name;
    }
}

